//
//	>>> R.G.B.A. - Rasters Girls Beer Atari by JAC! <<<
//
//	Created for Sillyventure 2012 in Gdansk.
//
//	Utility class to test steps rates for fading lines.

package com.wudsn.demos.atari800.rgba;


import java.util.Arrays;

public class RGBAStepRates {

    public static void main(String[] args) {

	new RGBAStepRates().run();
    }

    private void run() {
	testStepRates(0); // Fine
	testStepRates(1); // Never works
    }

    private void testStepRates(int withStart) {
	println("testStepRates("+withStart+"):");
	testStepRate(2, 99, 52*withStart);
	testStepRate(3, 100, 51*withStart);
	testStepRate(4, 99, 52*withStart);
	testStepRate(5, 99, 55*withStart);
	testStepRate(7, 99,55*withStart);
	println("");
    }

    private void testStepRate(int step, int fix, int start) {
	int y = 0;
	int z = 0;

	z = start;
	boolean[] array = new boolean[100];

	boolean first = true;
	for (int i = 1; i <= 100; i++) {

	    if (!array[z]) {
		array[z] = true;

	    } else {
		println("ERROR: step ="+step + " fix=" + fix + ": i=" + i + ": " + y + " ~ " + z
			+ " missing");
	    }
	    y = (i * step) % 100;
	    z = z + step;
	    if (z > 50 && first) {
		first = false;
		println("INFO: step ="+step + " fix=" + fix + ": i=" + i + ": " + y + " ~ " + z +" is median");
	    }
	    if (z >= 100) {
		z = z - fix;
	    }
	}
	println(Arrays.toString(array));
    }

    private void println(Object o) {
	System.out.println(o);
    }

}
