;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;
;	This a the loader which copies the packed data under the OS rom for the following initialization.

;===============================================================

	.proc init
	sei
sync	lda vcount
	bne sync
	lda #$fe
	sta portb
	mwa #nmi $fffa


	mwa #mpt_sound_load_start copy.source_adr
	mwa #mpt_sound_start_dfl copy.target_adr
	ldy #>[mpt_sound_load_end+255-mpt_sound_load_start]
	jsr copy

	mwa #field_chr_load_start copy.source_adr
	mwa #field_chr_dfl copy.target_adr
	ldy #>[field_chr_load_end+255-field_chr_load_start]
	jsr copy

	mwa #field_data_load_start copy.source_adr
	mwa #field_data_dfl copy.target_adr
	ldy #>[field_data_load_end+255-field_data_load_start]
	jsr copy

	lda #$ff
	sta portb
	cli
	rts

;===============================================================

	.proc nmi		;Temporary VBI
	pha
	txa
	pha
	tya
	pha
	jsr intro.header.effect.move
	pla
	tay
	pla
	tax
	pla
	rti
	.endp
	

;===============================================================

	.proc copy
	ldx #0 
loop	lda $ffff,x
source_adr = *-2
	sta $ffff,x
target_adr = *-2
	inx
	bne loop
	inc source_adr+1
	inc target_adr+1
	dey
	bne loop
	rts
	.endp

	.endp	
;===============================================================

	intro.loading.bar.next

mpt_sound_load_start
	ins "player/Silly-MPT-Sound.bin.dfl"
mpt_sound_load_end

	intro.loading.bar.next

field_chr_load_start
	ins "field/Silly-Field-6x8.chr.dfl"
field_chr_load_end

	intro.loading.bar.next

field_data_load_start
	ins "field/Silly-Field.dat.dfl",+$0000,$0900
	intro.loading.bar.next
	ins "field/Silly-Field.dat.dfl",+$0900,$0900
	intro.loading.bar.next
	ins "field/Silly-Field.dat.dfl",+$1200
	intro.loading.bar.next
field_data_load_end



